clipf(1)

NAME
clipf - Personal finance manager with command line interface

SYNOPSIS
clipf [<conf_dir>]

DESCRIPTION
Simple personal finance manager, allows one to track their income/expences by accounts and hierarchical categories. Store all data in flat text files.

ARGUMENTS

<conf_dir>
    Directory with configuration file and data files. Default to ~/.clipf/. If there is no such directory found at program startup, it would be created and populated by default configuration and empty data files.

DEFINITIONS
account - describe independent money storage, for which You want to track remains and turnover.

item - describe categories of Your incomes/expences. Can be nested as files/directories in file system.

item code - it is segmented unique identifier of item/item group. Period "." in item code define nesting levels. Period at the end of item code describe, that this item is group (have subling items).

operation - define single money transaction (income or expense).

tag - arbitrary string, used for additional classification of operations. Have the same nesting rules as items. Any number of tags can be added to each operation. It may be good idea to store available tags in item list.

USAGE
Type help to see available commands. Type help <command> to see online help about particular <command>.

For most reporting commands, output can be piped to external shell command the same way, as shell do.

COMMANDS CONCERNING ITEMS

prod add [-d] <item_code> <item_name>
    Add new item. Type <item_name> in quotes, if it contain spaces.

    -d  - define this item as income (default to expence).

prod rm <item_code_prefix>
    Remove all items, which code starts with <item_code_prefix>. This don't affect the operations list.

prod ls [<item_code>]
    Show one level of item list - direct sublings of <item_code>. Default to root level.

prod mv <old_item_code_prefix> <new_item_code_prefix>
    Update all item codes, which starts with <old_item_code_prefix>, replacing it to <new_item_code_prefix>. Item codes in operation list would be updated as well.

COMMANDS CONCERNING OPERATIONS

op add [-d <date>] [-a <account>] [-t <tag>] <item_code> <amount> [<note>]
    Add new operation

    -d <date>
        - override default operation date to <date>.

    -a <account>
        - override default operation account to <account>

    -t <tag>
        - label operation with <tag>. Any number of -t options can be used to add several tags to operation.

op ls [-t <tag_prefix>] [<item_code_prefix>]
    Show list of operations in current reporting period. If <item_code_prefix> specified, list would be limited by the operations, which item code starts with <item_code_prefix>. If '-t <tag_prefix>' option specified, limit output with operations, labelled with tag, starts with <tag_prefix>

COMMANDS CONCERNING REPORTING
Reporting period is always between <date_from> and <date_to> global options, which You set by set command.

rep prod [-t <tag_prefix>] [-a <account>] [<item_code>]
    Show turnover report for items (item groups), which are direct subling of <item_code> (default to root). Turnover for item group is summ of turnovers of all their nested items/groups.

    -t <tag_prefix>
        take into account only operations, labelled with tag, starts with <tag_prefix>

    -a <account>
        take into account only operations by <account> account.

rep acc
    Show remains and turnovers for all accounts.

OTHER COMMANDS

set <option> <value>
    Set global option <option> value to <value>. For date options, base format is Y-M-D. Leading 0 can be omitted. For the current year, year part can be omitted. For current month, year and month parts can be omitted. Available options:

    date
        - default date for new operations. Can be overridden by -d option of "op add".

    date_from

    date_to
        - reporting period for "op ls" and all "rep" subcommands.

    acc - default account for new operations. Can be overridden by -a option of "op add".

    max_lines
        - if number of lines in report output exceed this value, then "less" would be used to show report output.

show [<option>]
    Show current values of all global options or specified <option>.

calc <expression>
    Embedded calculator. Evaluate numeric expression and print the result.

ALIASES
Aliases is the simple way to make shortcuts for frequently used commands. Alias can be defined by the pair of strings: <command_line_prefix> and <prefix_substitution_string>. If command line starts with any of the defined aliases <command_line_prefix>, this prefix would be substituted with corresponding <prefix_substitution_string>. Examples can be found in system configuration file (see FILES ).

EXAMPLES

set date_from 2008-04-01
    - set reporting start period to 2008-04-01.

r prod
    - show turnover report by top level items.

op ls | grep foo | less
    pipe report output to shell command.

op ls | cat - >somefile.txt
    save report output to file

FILES
All configuration files have the same format - plain python code, that would be executed during clipf startup, in the context of main module. More specific configuration file can overwrite settings from more general one.

/etc/clipf.conf
    system-wide configuration file

~/.clipf.conf
    user-specific configuration

<config_path>/clipf.conf
    configuration-specific settings.

~/.clipf/
    Default configuration directory. Contain clipf.conf configuration file, and db/ subdirectory with data files.

AUTHOR
Denis Galtsev <galtsevdv@gmail.com>

SEE ALSO
Program site at: http://code.google.com/p/clipf/